#create and get SUT instance
SUT_id="$(aws ec2 run-instances --image-id ami-028188d9b49b32a80 --security-group-ids CloudVariability --count 1 --instance-type t2.medium --key-name influxdb --monitoring Enabled=false --query 'Instances[0].InstanceId' --placement 'AvailabilityZone=eu-west-1b')"
echo "SUT created, id= $SUT_id"
SUT_id="${SUT_id:1}"
SUT_id="${SUT_id::-1}"
echo "new id= $SUT_id"

echo "waiting for state running..."
instance_state="$(aws ec2 describe-instance-status --instance-id $SUT_id --output text --query InstanceStatuses[0].InstanceState.Code)"
until [ $instance_state = 16 ]; do
  sleep 1s
  instance_state="$(aws ec2 describe-instance-status --instance-ids $SUT_id --output text --query InstanceStatuses[0].InstanceState.Code)"
done
echo "SUT instance is running"

echo "Get SUT machine ip"
SUT_ip="$(aws ec2 describe-instances --instance-ids $SUT_id --query 'Reservations[0].Instances[0].PublicIpAddress')"
SUT_ip="${SUT_ip:1}"
SUT_ip="${SUT_ip::-1}"
echo "SUT ip: $SUT_ip"

echo "Wait for ports to be accessable..."
answer="$(nc -z -w 5 $SUT_ip 22)"
echo "nc answer was $answer"
(while [[ $answer != *"succeeded"* ]]; do
  echo "not accessablem, wait some more seconds..."
  answer="$(nc -z -w 5 $SUT_ip 22)"
done) &> /dev/null
echo "Ports accessable."

echo "Add ssh key..."
(ssh-keyscan $SUT_ip >> ~/.ssh/known_hosts)
echo "key added."

#Copy sut.sh and run on SUT
ssh -i "influxdb.pem" ec2-user@$SUT_ip 'bash -s' < initSUT.sh
echo "SUT initialized."

#Create and get Client instance
Client_id="$(aws ec2 run-instances --image-id ami-028188d9b49b32a80 --security-group-ids CloudVariability --count 1 --instance-type t2.medium --key-name influxdb --monitoring Enabled=false --query 'Instances[0].InstanceId' --placement 'AvailabilityZone=eu-west-1b')"
echo "Client created, id= $Client_id"
Client_id="${Client_id:1}"
Client_id="${Client_id::-1}"
echo "new id= $Client_id"

echo "waiting for state running..."
instance_state="$(aws ec2 describe-instance-status --instance-id $Client_id --output text --query InstanceStatuses[0].InstanceState.Code)"
until [ $instance_state = 16 ]; do
  sleep 1s
  instance_state="$(aws ec2 describe-instance-status --instance-ids $Client_id --output text --query InstanceStatuses[0].InstanceState.Code)"
done
echo "Client instance is running"

echo "Get Client machine ip"
Client_ip="$(aws ec2 describe-instances --instance-ids $Client_id --query 'Reservations[0].Instances[0].PublicIpAddress')"
Client_ip="${Client_ip:1}"
Client_ip="${Client_ip::-1}"
echo "Client ip: $Client_ip"

echo "Wait for ports to be accessable..."
answer="$(nc -z -w 5 $Client_ip 22)"
echo "nc answer was $answer"
(while [[ $answer != *"succeeded"* ]]; do
  echo "not accessablem, wait some more seconds..."
  answer="$(nc -z -w 5 $Client_ip 22)"
done) &> /dev/null
echo "Ports accessable."

echo "Add ssh key..."
(ssh-keyscan $Client_ip >> ~/.ssh/known_hosts)
echo "key added."

#Copy client.sh and run on Client (execute benchmark)
ssh -i "influxdb.pem" ec2-user@$Client_ip 'bash -s' < initClient.sh

echo "Client initialized."

echo "SUT_IP=$SUT_ip" > hosts.txt
echo "Client_IP=$Client_ip" >> hosts.txt