commit=2ab4cea
#workload=$1
workload=$1
foldername=$1
insertFileName=insertVictoria
runFileName=runVictoria

#Create EC2 instances and write IPs to hosts.txt, install Software, clone and instument SUT code
#execute initSUT.sh and initClient.sh
./initBenchmark.sh $commit
pwd
dir=$(pwd) 
source $dir/hosts.txt
echo "SUT_IP is $SUT_IP"
echo "Client_IP is $Client_IP"

#Start SUT and run workload (load phase)
./benchmark.sh $SUT_IP $Client_IP load $workload

#Shutdown SUT, get results and copy pprof file into folder
./getResults.sh $SUT_IP $insertFileName

#Start SUT and run workload (run phase)
./benchmark.sh $SUT_IP $Client_IP run $workload

#Shutdown SUT, get results and copy pprof file into folder
./getResults.sh $SUT_IP $runFileName

mkdir $foldername

mv $dir/$insertFileName.pprof $dir/$foldername
mv $dir/$runFileName.pprof $dir/$foldername
cd $dir/$foldername
go tool pprof -nodecount=3000 --nodefraction=0.002 --edgefraction=0.0 -svg $insertFileName.pprof > insert.svg
go tool pprof -nodecount=3000 --nodefraction=0.002 --edgefraction=0.0 -dot $insertFileName.pprof > insert.dot
go tool pprof -nodecount=3000 --nodefraction=0.002 --edgefraction=0.0 -svg $runFileName.pprof > run.svg
go tool pprof -nodecount=3000 --nodefraction=0.002 --edgefraction=0.0 -dot $runFileName.pprof > run.dot
